////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                //
// BeDVI                                                                                                          //
// by Achim Blumensath                                                                                            //
// blume@corona.oche.de                                                                                           //
//                                                                                                                //
// This program is free software! It may be distributed according to the GNU Public License (see COPYING).        //
//                                                                                                                //
// $Id: BeDVI.h,v 1.4 1997/04/27 17:41:29 achim Exp achim $
//                                                                                                                //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef VIEWDVI_H
#define VIEWDVI_H

#ifndef _APPLICATION_H
#include <Application.h>
#endif
#ifndef DEFINES_H
#include "defines.h"
#endif
#ifndef DVI_H
#include "DVI.h"
#endif

#include "Support.h"

class BPositionIO;
class DisplayInfo;
class DStream;
class DVIView;
class ViewWindow;

#define VERSION "V1.31"

// Messages:

static const uint32 MsgOpenPanel    = 'opnl';
static const uint32 MsgOpenFile     = 'open';
static const uint32 MsgAntiAliasing = 'grey';
static const uint32 MsgBorderLine   = 'bord';
static const uint32 MsgMeasureWin   = 'mwin';
static const uint32 MsgSearch       = 'find';
static const uint32 MsgNext         = 'next';
static const uint32 MsgPrev         = 'prev';
static const uint32 MsgFirst        = 'frst';
static const uint32 MsgLast         = 'last';
static const uint32 MsgSaveSettings = 'svst';
static const uint32 MsgPage         = 'page';

class ViewApplication: public BApplication
{
  private:
    ViewWindow *win;
    DVIView    *vw;
    BFilePanel *OpenPanel;
    entry_ref  PanelDirectory;

  public:
    // settings:

    DVISettings Settings;
    BRect       WindowBounds;

            ViewApplication();
    virtual ~ViewApplication();

    virtual void ArgvReceived(int32 argc, char **argv);
    virtual void RefsReceived(BMessage *msg);
    virtual bool QuitRequested();
    virtual void AboutRequested();
    virtual void CloseFilePanel();
    virtual void MessageReceived(BMessage *msg);

    void LaunchFilePanel();
    void OpenFile(entry_ref File);
    void SetResolution(u_int PixelsPerInch, u_int ShrinkFactor);
    void ToggleAntiAliasing();
    void UpdateMenus();

    static void DisplayError(const char *msg);

    bool Ok()
    {
      return win != NULL && vw != NULL;
    }
};

bool       InitAppMenu();
ViewWindow *InitWindow();
void       SetSleepCursor();
void       SetNormalCursor();

#endif
