////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                //
// BeDVI                                                                                                          //
// by Achim Blumensath                                                                                            //
// blume@corona.oche.de                                                                                           //
//                                                                                                                //
// This program is free software! It may be distributed according to the GNU Public License (see COPYING).        //
//                                                                                                                //
// $Id: DVI-View.h,v 1.4 1997/04/27 17:41:29 achim Exp achim $
//                                                                                                                //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef VW_VIEW_H
#define VW_VIEW_H

#ifndef _VIEW_H
#include <View.h>
#endif
#ifndef DEFINES_H
#include "defines.h"
#endif
#ifndef DVI_H
#include "DVI.h"
#endif

class DVIView: public BView
{
  private:
    sem_id     DocLock;
    DVI        *Document;

    sem_id     BufferLock;
    BBitmap    *Buffer;
    BView      *BufferView;

    u_int      PageNo;

  public:
            DVIView(BRect frame, const char *Name);
    virtual ~DVIView();

    virtual void Draw(BRect updateRect);
    virtual void FrameResized(float Width, float Height);
    virtual void KeyDown(const char *bytes, int32 numBytes);
    virtual void MessageReceived(BMessage *msg);

    void SetDocument(DVI *doc);
    bool SetPage(u_int no);
    bool IncPage();
    bool DecPage();
    void ToggleBorderLine();
    void ToggleAntiAliasing();
    void UpdateWindowSize();
    void UpdateScrollBars();
    void UpdateWindow();
    void UpdateMenus();
    void RedrawBuffer();
    bool DocumentChanged();
    void SetDspInfo(DisplayInfo *dsp);

    bool Ok()
    {
      return (DocLock    >= B_NO_ERROR) &&
             (BufferLock >= B_NO_ERROR) &&
             (BufferView != NULL);
    }

  friend class DVI;
  friend class Font;
  friend class FontInfo;
};

#endif
